﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Zadatak02
{
    internal class Program
    {
        private const string PATH = @"D:\Silvije\OOP\DATA\text.txt";
        static void Main(string[] args)
        {
            //ReadFileTest(PATH);
            try 
            { 
                WriteFile(PATH, "trla lala!!!");
                ReadFile(PATH);
            }
            catch(Exception e)
            {
                Console.WriteLine(e.Message);
            }
            UsingDemo();
        }

        private static void UsingDemo()
        {
            using (Dummy dummy = new Dummy())
            {
                //throw new Exception();
                //return;
            }
        }

        private static void ReadFile(string pATH)
        {
            //StreamReader reader = new StreamReader(pATH);
            //reader.ReadToEnd();
            //Console.WriteLine(reader.ReadToEnd());
            using (StreamReader reader = File.OpenText(pATH))
            {
                Console.WriteLine(reader.ReadToEnd());
            }
        }

        private static void WriteFile(string path, string text)
        {
            using (StreamWriter writer = File.CreateText(path))
            {
                writer.WriteLine(text);
            }
            //StreamWriter writer = new StreamWriter(path);
            //writer.WriteLine(text);
        }

        private static void ReadFileTest(string path)
        {
            //1 korak -- datoteka ne postoji i izbacuje se exceptions, TO JE DOBRO!
            //StreamReader reader=File.OpenText(path);
            //Console.WriteLine(reader.ReadToEnd());
            //reader.Close();

            //2 korak- catch koji lovi više grešaka
            //ako postoji directorij, a ne postoji datoteka - greška FileNotFoundException!
            //ukoliko imate File.OpenText

            StreamReader reader = null;
            try
            {
                //StreamReader reader1 = File.OpenText(PATH);
                reader = File.OpenText(PATH);
                Console.WriteLine(reader.ReadToEnd());
                //reader.Dispose();   
            }
            catch (DirectoryNotFoundException e)
            { 
                Console.WriteLine(e.Message);
            }
            catch (FileNotFoundException e)
            { Console.WriteLine(e.Message); }
            catch (Exception ex)
            {
                Console.WriteLine(ex.Message);
            }
            finally
            {
                //if (reader != null)
                //    reader.Dispose();
                reader?.Dispose(); //NULL ConDITIONAL OPERATOR
            }
        }
    }
}
